#include "winbase.h"
#include "wingdi.h"
#include "winerror.h"
#include "wine/debug.h"

WINE_DEFAULT_DEBUG_CHANNEL(msimg32);

BOOL WINAPI GradientFill(HDC hdc, PTRIVERTEX pVertex, ULONG nVertex, 
                         PVOID pMesh, ULONG dwNumMesh, ULONG dwMode )
{
  FIXME("stub: %ld vertices %ld gradients mode %lx\n", nVertex, dwNumMesh, dwMode);
  SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
  return FALSE;
}

BOOL WINAPI TransparentBlt(HDC hdcDest,
			   int nXOriginDest, int nYOriginDest,
			   int nWidthDest, int nHeightDest,
			   HDC hdcSrc,
			   int nXOriginSrc, int nYOriginSrc,
			   int nWidthSrc, int nHeightSrc,
			   UINT crTransparent)
{
  COLORREF bkcol;
  HBITMAP hbmMask, hbmImage, hbmTemp;
  HDC hdcMask, hdcImage, hdcTemp;

  TRACE("(%d, (%d,%d),(%d,%d), %d, (%d,%d),(%d,%d), %d) - not optimized\n",
        hdcDest, nXOriginDest, nYOriginDest, nWidthDest, nHeightDest,
	hdcSrc, nXOriginSrc, nYOriginSrc, nWidthSrc, nHeightSrc, crTransparent);

  /* FIXME: we do not support other map modes than MM_TEXT */
  /* FIXME: we're also supposed to do something about the StretchBltMode */

  /* create monochrome bitmap for the transparent pixels */
  hbmMask = CreateBitmap(nWidthSrc, nHeightSrc, 1, 1, NULL);
  hdcMask = CreateCompatibleDC(hdcDest);
  SelectObject(hdcMask, hbmMask);
  bkcol = SetBkColor(hdcSrc, crTransparent);
  BitBlt(hdcMask, 0, 0, nWidthSrc, nHeightSrc, hdcSrc, nXOriginSrc, nYOriginSrc, SRCCOPY);
  SetBkColor(hdcSrc, bkcol);

  /* create color bitmap for the source image */
  hbmImage = CreateCompatibleBitmap(hdcDest, nWidthSrc, nHeightSrc);
  hdcImage = CreateCompatibleDC(hdcDest);
  SelectObject(hdcImage, hbmImage);
  BitBlt(hdcImage, 0, 0, nWidthSrc, nHeightSrc, hdcSrc, nXOriginSrc, nYOriginSrc, SRCCOPY);
  /* remove color key from it */
  BitBlt(hdcImage, 0, 0, nWidthSrc, nHeightSrc, hdcMask, 0, 0, 0x220326);

#if 1
  /* The two StretchBlts could be done directly on the destination, but to avoid
   * flicker, we'll copy the destination and work on that instead. This is slower,
   * but easier on the eyes. */
  hbmTemp = CreateCompatibleBitmap(hdcDest, nWidthDest, nHeightDest);
  hdcTemp = CreateCompatibleDC(hdcDest);
  SelectObject(hdcTemp, hbmTemp);
  BitBlt(hdcTemp, 0, 0, nWidthDest, nHeightDest, hdcDest, nXOriginDest, nYOriginDest, SRCCOPY);

  /* clear the destination parts we don't want */
  StretchBlt(hdcTemp, 0, 0, nWidthDest, nHeightDest,
             hdcMask, 0, 0, nWidthSrc, nHeightSrc,
             SRCAND);
  /* fill them with the source parts we want */
  StretchBlt(hdcTemp, 0, 0, nWidthDest, nHeightDest,
             hdcImage, 0, 0, nWidthSrc, nHeightSrc,
             SRCPAINT);

  /* blit the modifications back to the real destination */
  BitBlt(hdcDest, nXOriginDest, nYOriginDest, nWidthDest, nHeightDest, hdcTemp, 0, 0, SRCCOPY);

  DeleteDC(hdcTemp);
  DeleteObject(hbmTemp);
#else
  /* flickerful version */

  /* clear the destination parts we don't want */
  StretchBlt(hdcDest, nXOriginDest, nYOriginDest, nWidthDest, nHeightDest,
             hdcMask, 0, 0, nWidthSrc, nHeightSrc,
             SRCAND);
  /* fill them with the source parts we want */
  StretchBlt(hdcDest, nXOriginDest, nYOriginDest, nWidthDest, nHeightDest,
             hdcImage, 0, 0, nWidthSrc, nHeightSrc,
             SRCPAINT);
#endif

  DeleteDC(hdcImage);
  DeleteObject(hbmImage);
  DeleteDC(hdcMask);
  DeleteObject(hbmMask);

  return TRUE;
}

BOOL WINAPI AlphaBlend(HDC hdcDest,
                       int nXOriginDest, int nYOriginDest,
                       int nWidthDest, int nHeightDest,
		       HDC hdcSrc,
		       int nXOriginSrc, int nYOriginSrc,
		       int nWidthSrc, int nHeightSrc,
		       BLENDFUNCTION blendFunction)
{
  FIXME("(%d, (%d,%d),(%d,%d), %d, (%d,%d),(%d,%d), (%d,%d,%d,%d)) stub!\n",
        hdcDest, nXOriginDest, nYOriginDest, nWidthDest, nHeightDest,
	hdcSrc, nXOriginSrc, nYOriginSrc, nWidthSrc, nHeightSrc, 
	blendFunction.BlendOp, blendFunction.BlendFlags, 
	blendFunction.SourceConstantAlpha, blendFunction.AlphaFormat);
  SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
  return FALSE;
}
